# Contribution Guidelines

Thanks for your interest in contributing this project. All issues and pull requests are highly appreciated!

## Pull Requests

Before sending a pull request to this project, please read and follow guidelines:

1. Branch: We only accept pull requests on the `master` branch
2. Coding style: Follow the coding style used in DoraemonKit
3. Commit message: Use English and check your spelling
4. Test: Make sure to test your code

Add device mode, API version, related log, screenshots and other related information in your pull request if possible.

NOTE: We assume all contributions can be licensed under the [Apache License 2.0](https://github.com/didi/DoraemonKit/blob/master/LICENSE).

## Issues

We love clearly described issues. :)

The following information can help us resolve the issue faster:

* Device mode and hardware information
* API version
* Logs
* Screenshots
* Steps to reproduce the issue
